org.apache.ignite.internal.visor.misc

## Class VisorNopTask

- java.lang.Object
- - org.apache.ignite.internal.visor.misc.VisorNopTask

All Implemented Interfaces:
  Serializable, ComputeTask<Integer,Void>

    public class VisorNopTask
    extends Object
    implements ComputeTask<Integer,Void>

Nop task with random timeout.

See Also:
  Serialized Form

### Constructor Summary

Constructors
Constructor and Description
`VisorNopTask()`

### Method Summary

All Methods Instance Methods Concrete Methods
`Map<? extends ComputeJob,ClusterNode>` `map(List<ClusterNode> subgrid, Integer arg)` This method is called to map or split grid task into multiple grid jobs.
`Void` `reduce(List<ComputeJobResult> results)` Reduces (or aggregates) results received so far into one compound result to be returned to caller via `ComputeTaskFuture.get()` method.
`ComputeJobResultPolicy` `result(ComputeJobResult res, List<ComputeJobResult> rcvd)` Asynchronous callback invoked every time a result from remote execution is received.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### VisorNopTask

    public VisorNopTask()

### Method Detail

#### map

    @Nullable
    public Map<? extends ComputeJob,ClusterNode> map(List<ClusterNode> subgrid,
                                                               @Nullable
                                                               Integer arg)

This method is called to map or split grid task into multiple grid jobs. This is the first method that gets called when task execution starts.

Specified by:
  `map` in interface `ComputeTask<Integer,Void>`
Parameters:
  `subgrid` - Nodes available for this task execution. Note that order of nodes is guaranteed to be randomized by container. This ensures that every time you simply iterate through grid nodes, the order of nodes will be random which over time should result into all nodes being used equally.
  `arg` - Task execution argument. Can be `null`. This is the same argument as the one passed into `Grid#execute(...)` methods.
Returns:
  Map of grid jobs assigned to subgrid node. Unless `ComputeTaskContinuousMapper` is injected into task, if `null` or empty map is returned, exception will be thrown.

#### result

    public ComputeJobResultPolicy result(ComputeJobResult res,
                                         List<ComputeJobResult> rcvd)

Asynchronous callback invoked every time a result from remote execution is received. It is ultimately upto this method to return a policy based on which the system will either wait for more results, reduce results received so far, or failover this job to another node. See `ComputeJobResultPolicy` for more information about result policies.

Specified by:
  `result` in interface `ComputeTask<Integer,Void>`
Parameters:
  `res` - Received remote grid executable result.
  `rcvd` - All previously received results. Note that if task class has `ComputeTaskNoResultCache` annotation, then this list will be empty.
Returns:
  Result policy that dictates how to process further upcoming job results.

#### reduce

    @Nullable
    public Void reduce(List<ComputeJobResult> results)

Reduces (or aggregates) results received so far into one compound result to be returned to caller via `ComputeTaskFuture.get()` method.

Note, that if some jobs did not succeed and could not be failed over then the list of results passed into this method will include the failed results. Otherwise, failed results will not be in the list.

Specified by:
  `reduce` in interface `ComputeTask<Integer,Void>`
Parameters:
  `results` - Received results of broadcasted remote executions. Note that if task class has `ComputeTaskNoResultCache` annotation, then this list will be empty.
Returns:
  Grid job result constructed from results of remote executions.

2018 Copyright © Apache Software Foundation

Follow @ApacheIgnite

Ignite Fabric | : ver. 2.4.0
Release Date | : March 5 2018